USES CRT,GRAPH13H;
CONST Distance=400; {Odleglosc bryly od obserwatora}

TYPE Punkt3D= record
 X,Y,Z: integer;
END;

VAR Xangle,Yangle,Zangle:integer;
    TloBufor,LogoBufor,WszystkieKulkiBufor:pointer;
    LogoSize,WszystkieKulkiSize:word;
    LogoPaleta:array [0..70*3-1] of byte;
    KulkiPaleta:array [0..30*3-1] of byte;
    Kulka:array [0..8] of pointer;
    KulkaSize:word;
    IloscWierzcholkow:word;
    _Cos,_Sin:array [0..359] of real;
    ObiektWzor,ObiektObrot:array [0..500] of Punkt3D;
    ObiektSortOsZ:array [0..500] of integer;
    PosortowanaOsZ:array [0..500] of word;
    i,j:integer;
    z:char;
    TrybWyswietlania,StaryTryb:boolean;

{Funkcja odszukujaca w lancuchu znakow zadany tekst}
FUNCTION FindText (S,Text:string;StartPosition:integer):integer;
VAR i,j:integer;
    OdnalezioneZnaki:byte;
    MiejsceZnalezienia:integer;

BEGIN
 i:=StartPosition-1;
 MiejsceZnalezienia:=-1;

 IF Length (S)-Length (Text)>=0 THEN
 BEGIN
  REPEAT
   Inc (i);
   OdnalezioneZnaki:=0;
   FOR j:=0 TO Length (Text)-1 DO
    IF S [i+j]=Text [j+1] THEN Inc (OdnalezioneZnaki);
   IF OdnalezioneZnaki=Length (Text) THEN MiejsceZnalezienia:=i;
  UNTIL (i=Length (S)-Length (Text))OR(MiejsceZnalezienia<>-1);
 END;
 FindText:=MiejsceZnalezienia;
END;

{Funkcja zamieniajaca znajdujaca sie, na podanej pozycji w}
{lancuchu znakow, liczbe na odpowiadajaca typu Integer}
FUNCTION GetNumber (S:string;StartPosition:integer):integer;
VAR i,j:integer;
    NumberText:string;
    Number:real;
    Code:word;

BEGIN
 {Szuka miejsca, gdzie konczy sie zapis liczby}
 j:=FindText (S,' ',StartPosition)-1;
 {Jesli nie znalazl konca liczby oznacza to, ze jest nim}
 {koniec wiersza}
 IF j=-2 THEN j:=Length (s);

 NumberText:='';
 FOR i:=StartPosition To j DO NumberText:=NumberText+S [i];
 Val (NumberText,Number,Code);
 GetNumber:=Round (Number);
END;

{Procedura wczytujaca do pamieci ksztalt bryly 3D z pliku}
{zapisanego w formacie ASC spod "3D STUDIO"}
PROCEDURE LoadVectorObject;
VAR i:integer;
    F:text;
    S:string;

BEGIN
 IF ParamStr (1)='' THEN
 BEGIN
  Writeln ('Vector Balls');
  Writeln ('parametr: Vector.EXE plik.ASC');
  Writeln;
  Writeln ('plik.ASC - plik w formacie ASC, spod "3D Studio", z definicja');
  Writeln ('           obracanego obiektu.');
  Halt;
 END;

 Assign (F,ParamStr (1));
 {$I-}
 Reset (F);
 IF IOResult<>0 THEN
 BEGIN
  Writeln ('Blad otwarcia pliku !');
  Halt;
 END;
 {$I+}

 REPEAT    {Szukanie, w pliku, sygnatury VERTICES}
  ReadLn (F,S);
  i:=FindText (S,'Vertices: ',1);
 UNTIL (i<>-1)OR(EOF (F));

 {Odczytuje ile wierzcholkow ma bryla}
 IloscWierzcholkow:=GetNumber (S,i+Length ('Vertices: '));

 ReadLn (F,S); {Jeden wiersz w dol}

 i:=0;
 {Odczyt pozycji X, Y i Z poszczegolnych wierzcholkow}
 REPEAT
  ReadLn (F,S);
  IF FindText (S,'Vertex',1)<>-1 THEN
  BEGIN
   ObiektWzor [i].x:=GetNumber (S,FindText (s,'X: ',1)+length ('X: '));
   ObiektWzor [i].y:=GetNumber (S,FindText (s,'Y: ',1)+length ('Y: '));
   ObiektWzor [i].z:=GetNumber (S,FindText (s,'Z: ',1)+length ('Z: '));
   Inc (i);
  END;
 UNTIL i=IloscWierzcholkow;
 Close (F);
END;

{Procedura wyliczajaca pozycje wierzcholkow przesuniete o kat}
{i wyswietlajaca bryle na ekranie}
PROCEDURE Draw3Dobject;
VAR Nx,Ny,Nz:integer;
    PunktBlizszy:word;

BEGIN
 SegVga:=Seg (TloBufor^);
 OfsVga:=Ofs (TloBufor^)+4;

 FOR i:=0 TO IloscWierzcholkow-1 DO
 BEGIN
  {Czyszczenie starego punktu lub kulki w buforze}
  IF StaryTryb THEN
   PutBitMap (ObiektObrot [i].X-6,ObiektObrot [i].Y-5,
    Seg (Kulka [8]^),Ofs (Kulka [8]^))
  ELSE PutPixel (ObiektObrot [i].X,ObiektObrot [i].Y,0);

  {Obrot wzgledem osi X}
  Ny:=Round (ObiektWzor [i].Y*_Cos [Xangle]-ObiektWzor [i].Z*_Sin [Xangle]);
  Nz:=Round (ObiektWzor [i].Y*_Sin [Xangle]+ObiektWzor [i].Z*_Cos [Xangle]);
  Nx:=Round (ObiektWzor [i].X);
  ObiektObrot [i].X:=Nx;
  ObiektObrot [i].Y:=Ny;
  ObiektObrot [i].Z:=Nz;

  {Obrot wzgledem osi Y}
  Nx:=Round (ObiektObrot [i].X*_Cos [Yangle]-ObiektObrot [i].Z*_Sin[Yangle]);
  Nz:=Round (ObiektObrot [i].X*_Sin [Yangle]+ObiektObrot [i].Z*_Cos [Yangle]);
  ObiektObrot [i].X:=Nx;
  ObiektObrot [i].Z:=Nz;

  {Obrot wzgledem osi Z}
  Nx:=Round (ObiektObrot [i].X*_Cos [Zangle]-ObiektObrot [i].Y*_Sin [Zangle]);
  Ny:=Round (ObiektObrot [i].X*_Sin [Zangle]+ObiektObrot [i].Y*_Cos [Zangle]);
  ObiektObrot [i].X:=Nx;
  ObiektObrot [i].Y:=Ny;

  {Perspektywa}
  Dec (ObiektObrot [i].Z,Distance);
  ObiektObrot [i].X:=Round ((ObiektObrot [i].X*256)/ObiektObrot [i].Z+160);
  ObiektObrot [i].Y:=Round ((ObiektObrot [i].Y*256)/ObiektObrot [i].Z+100);
  Inc (ObiektObrot [i].Z,Distance);
 END;

 FOR i:=0 To IloscWierzcholkow-1 DO ObiektSortOsZ [i]:=ObiektObrot [i].Z;

 {Segregacja wierzcholkow pod wzgledem pozycji na osi Z}
 PunktBlizszy:=0;
 FOR i:=0 TO IloscWierzcholkow-1 DO
 BEGIN
  FOR j:=0 TO IloscWierzcholkow-1 DO
   IF ObiektSortOsZ [j]>=ObiektSortOsZ [PunktBlizszy] THEN PunktBlizszy:=j;
  PosortowanaOsZ [IloscWierzcholkow-1-i]:=PunktBlizszy;
  ObiektSortOsZ [PunktBlizszy]:=-1000;
 END;

 IF TrybWyswietlania THEN
  FOR i:=0 TO IloscWierzcholkow-1 DO
   PutSprite (ObiektObrot [PosortowanaOsZ [i]].X-6,
    ObiektObrot [PosortowanaOsZ [i]].Y-5,
     Seg (Kulka [(ObiektObrot [PosortowanaOsZ [i]].Z+100) DIV 28]^),
      Ofs (Kulka [(ObiektObrot [PosortowanaOsZ [i]].Z+100) DIV 28]^),20)
 ELSE FOR i:=0 To IloscWierzcholkow-1 DO
 {W trybie wyswietlania punktow, piksele nie musza byc}
 {segregowane}
 PutPixel (ObiektObrot [i].X,ObiektObrot [i].Y,15);

 SegVga:=$0a000;
 OfsVga:=0;
 CopyMem (Seg (TloBufor^),Ofs (TloBufor^)+4,$0a000,0,64000);
END;

BEGIN
 LoadVectorObject;

 {Wczytanie do pamieci kulek}
 WszystkieKulkiSize:=GetUBMWidth ('Kulki.ubm')*GetUBMHeight ('Kulki.ubm')+4;
 GetMem (WszystkieKulkiBufor,WszystkieKulkiSize);
 LoadUBM ('Kulki.ubm',Seg (WszystkieKulkiBufor^),Ofs (WszystkieKulkiBufor^),
          Seg (KulkiPaleta),Ofs (KulkiPaleta));

 {Wczytanie do pamieci loga}
 LogoSize:=GetUBMWidth ('Logo.ubm')*GetUBMHeight ('Logo.ubm')+4;
 GetMem (LogoBufor,LogoSize);
 LoadUBM ('Logo.ubm',Seg (LogoBufor^),Ofs (LogoBufor^),
          Seg (LogoPaleta),Ofs (LogoPaleta));

 SegVga:=Seg (WszystkieKulkiBufor^);
 OfsVga:=Ofs (WszystkieKulkiBufor^)+4;

 KulkaSize:=12*10+4; {Rozmiar bufora na jedna kulke}
 {Pobranie poszczegolnych kulke do odrebnych buforow}
 FOR i:=0 TO 8 DO
 BEGIN
  GetMem (Kulka [i],KulkaSize);
  GetBitMap (i*15+2,0,i*15+13,9,Seg (Kulka [i]^),Ofs (Kulka [i]^));
 END;

 SegVga:=$0a000;
 OfsVga:=0;

 InitGraph ($13);

 SetRGBBlock (GetFirstColor ('Kulki.ubm'),
  GetLengthPalette ('Kulki.ubm'),Seg (KulkiPaleta),Ofs (KulkiPaleta));
 SetRGBBlock (GetFirstColor ('Logo.ubm'),
  GetLengthPalette ('Logo.ubm'),Seg (LogoPaleta),Ofs (LogoPaleta));

 PutBitMap (245,165,Seg (LogoBufor^),Ofs (LogoBufor^));

 FOR i:=0 TO 359 DO
 BEGIN
  _Sin [i]:=Cos (i*PI/180);
  _Cos [i]:=Sin (i*PI/180);
 END;

 GetMem (TloBufor,64004);
 GetBitMap (0,0,319,199,Seg (TloBufor^),Ofs (TloBufor^));

 {Glowna petla programu}
 TrybWyswietlania:=true;
 REPEAT
  Inc (Xangle);
  Inc (Yangle);
  Inc (Zangle);

  IF Xangle>=359 THEN Xangle:=0;
  IF Yangle>=359 THEN Yangle:=0;
  IF Zangle>=359 THEN Zangle:=0;

  Draw3Dobject;

  StaryTryb:=TrybWyswietlania;
  IF KeyPressed THEN
  BEGIN
   z:=ReadKey;
   CASE z OF
    ';': TrybWyswietlania:=true;  {F1}
    '<': TrybWyswietlania:=false; {F2}
   END;
  END;
 UNTIL z=#27;

 InitGraph ($3);
END.