USES CRT;
CONST Distance=400; {Odlego bryy od obserwatora}

TYPE Punkt3D= record
 X,Y,Z: integer;
END;

VAR Xangle,Yangle,Zangle:integer;
    IloscWierzcholkow:word;
    _Cos,_Sin:array [0..359] of real;
    ObiektWzor,ObiektObrot:array [0..500] of Punkt3D;
    i,j:integer;

{Procedura stawiajca punkt o wsprzdnych X, Y i danym}
{kolorze}
PROCEDURE PutPixel (X,Y:word;Kolor:byte); ASSEMBLER;
ASM
 PUSH ES
 MOV AX,$a000
 MOV ES,AX
 MOV AX,X
 MOV BX,Y
 MOV CL,6
 SHL BX,CL {mnoy wsp. Y przez 2 do potgi 6, czyli 64}
 MOV CX,BX {wynik mnoenia zapisuje w CX}
 SHL BX,1  {BX mnoy przez 2}
 SHL BX,1  {i jeszcze przez 2 ; razem przez 4}
 ADD BX,CX {sumuje 64*4 i 64 co daje 320 (razy Y)}
 ADD BX,AX {do 320*Y dodaje X}
 MOV DL,Kolor
 MOV ES:[BX],DL
 POP ES
END;

{Procedura przeczajca tryby graficzne}
PROCEDURE InitGraph (Tryb:byte); ASSEMBLER;
ASM
 MOV AH,00H
 MOV AL,Tryb
 INT 10H
END;

{Procedura czekajca na powrt pionowy}
PROCEDURE GraphWait; ASSEMBLER;
ASM
 MOV DX,03daH
@CZEKAJ:
 IN AL,DX
 TEST AL,8
 JE @CZEKAJ
END;

{Funkcja odszukujca w acuchu znakw zadany tekst}
FUNCTION FindText (S,Text:string;StartPosition:integer):
                                                 integer;
VAR i,j:integer;
    OdnalezioneZnaki:byte;
    MiejsceZnalezienia:integer;

BEGIN
 i:=StartPosition-1;
 MiejsceZnalezienia:=-1;

 IF Length (S)-Length (Text)>=0 THEN
 BEGIN
  REPEAT
   Inc (i);
   OdnalezioneZnaki:=0;
   FOR j:=0 TO Length (Text)-1 DO
    IF S [i+j]=Text [j+1] THEN Inc (OdnalezioneZnaki);
   IF OdnalezioneZnaki=Length (Text) THEN
                               MiejsceZnalezienia:=i;
  UNTIL (i=Length (S)-Length (Text))
        OR(MiejsceZnalezienia<>-1);
 END;
 FindText:=MiejsceZnalezienia;
END;

{Funkcja zamieniajca znajdujc si, na podanej pozycji w}
{acuchu znakw, liczb na odpowiadajc typu Integer}
FUNCTION GetNumber (S:string;StartPosition:integer):integer;
VAR i,j:integer;
    NumberText:string;
    Number:real;
    Code:word;

BEGIN
 {Szuka miejsca, gdzie koczy si zapis liczby}
 j:=FindText (S,' ',StartPosition)-1;
 {Jeli nie znalaz koca liczby oznacza to, e jest nim}
 {koniec wiersza}
 IF j=-2 THEN j:=Length (s);

 NumberText:='';
 FOR i:=StartPosition To j DO NumberText:=NumberText+S [i];
 Val (NumberText,Number,Code);
 GetNumber:=Round (Number);
END;

{Procedura wczytujca do pamici ksztat bryy 3D z pliku}
{zapisanego w formacie ASC spod "3D STUDIO"}
PROCEDURE LoadVectorObject;
VAR i:integer;
    F:text;
    S:string;

BEGIN
 IF ParamStr (1)='' THEN
 BEGIN
  WriteLn ('Punktowa animacja bryy zapisanej w *.ASC');
  WriteLn ('parametr: Vector.EXE plik.ASC');
  WriteLn;
  Write ('plik.ASC - plik w formacie ASC, spod ');
  WriteLn ('"3D Studio", z definicja');
  WriteLn ('           obracanego obiektu.');
  Halt;
 END;

 Assign (F,ParamStr (1));
 {$I-}
 Reset (F);
 IF IOResult<>0 THEN
 BEGIN
  Writeln ('Blad otwarcia pliku !');
  Halt;
 END;
 {$I+}

 REPEAT    {Szukanie, w pliku, sygnatury VERTICES}
  ReadLn (F,S);
  i:=FindText (S,'Vertices: ',1);
 UNTIL (i<>-1)OR(EOF (F));

 {Odczytuje ile wierzchokw ma brya}
 IloscWierzcholkow:=GetNumber (S,i+Length ('Vertices: '));

 ReadLn (F,S); {Jeden wiersz w d}

 i:=0;
 {Odczyt pozycji X, Y i Z poszczeglnych wierzchokw}
 REPEAT
  ReadLn (F,S);
  IF FindText (S,'Vertex',1)<>-1 THEN
  BEGIN
   ObiektWzor [i].x:=
         GetNumber (S,FindText (s,'X: ',1)+length ('X: '));
   ObiektWzor [i].y:=
         GetNumber (S,FindText (s,'Y: ',1)+length ('Y: '));
   ObiektWzor [i].z:=
         GetNumber (S,FindText (s,'Z: ',1)+length ('Z: '));
   Inc (i);
  END;
 UNTIL i=IloscWierzcholkow;
 Close (F);
END;

{Procedura wyliczajca pozycj wierzchokw}
{przeksztaconych o kt i wywietlajca brye na ekranie}
PROCEDURE Draw3Dobject;
VAR Nx,Ny,Nz:integer;
    PunktBlizszy:word;

BEGIN
 FOR i:=0 TO IloscWierzcholkow-1 DO
 BEGIN
  {Wymazanie starego punktu lub kulki z ekranu}
  PutPixel (ObiektObrot [i].X,ObiektObrot [i].Y,0);

  {Obrt wzgldem osi X}
  Ny:=Round (ObiektWzor [i].Y*_Cos [Xangle]
      -ObiektWzor [i].Z*_Sin [Xangle]);
  Nz:=Round (ObiektWzor [i].Y*_Sin [Xangle]
      +ObiektWzor [i].Z*_Cos [Xangle]);
  Nx:=Round (ObiektWzor [i].X);
  ObiektObrot [i].X:=Nx;
  ObiektObrot [i].Y:=Ny;
  ObiektObrot [i].Z:=Nz;

  {Obrt wzgldem osi Y}
  Nx:=Round (ObiektObrot [i].X*_Cos [Yangle]
      -ObiektObrot [i].Z*_Sin[Yangle]);
  Nz:=Round (ObiektObrot [i].X*_Sin [Yangle]
      +ObiektObrot [i].Z*_Cos [Yangle]);
  ObiektObrot [i].X:=Nx;
  ObiektObrot [i].Z:=Nz;

  {Obrt wzgldem osi Z}
  Nx:=Round (ObiektObrot [i].X*_Cos [Zangle]
      -ObiektObrot [i].Y*_Sin [Zangle]);
  Ny:=Round (ObiektObrot [i].X*_Sin [Zangle]
      +ObiektObrot [i].Y*_Cos [Zangle]);
  ObiektObrot [i].X:=Nx;
  ObiektObrot [i].Y:=Ny;

  {Perspektywa}
  Dec (ObiektObrot [i].Z,Distance);
  ObiektObrot [i].X:=Round ((ObiektObrot [i].X*256)
                     /ObiektObrot [i].Z+160);
  ObiektObrot [i].Y:=Round ((ObiektObrot [i].Y*256)
                     /ObiektObrot [i].Z+100);
  Inc (ObiektObrot [i].Z,Distance);
 END;

 {Wywietlanie punktw.}
 {Poniewa punkty reprezentowane s poprzez pojedyncze}
 {piksle, przed ich wywietleniem nie trzeba przeprowadza}
 {sortowania pod wzgldem odlegoci od ekranu.}
 FOR i:=0 To IloscWierzcholkow-1 DO
 PutPixel (ObiektObrot [i].X,ObiektObrot [i].Y,15);
END;

BEGIN
 LoadVectorObject;

 InitGraph ($13);

 FOR i:=0 TO 359 DO
 BEGIN
  _Sin [i]:=Cos (i*PI/180);
  _Cos [i]:=Sin (i*PI/180);
 END;

 {Gwna ptla programu}
 REPEAT
  Inc (Xangle);
  Inc (Yangle);
  Inc (Zangle);

  IF Xangle>359 THEN Xangle:=Xangle-360;
  IF Yangle>359 THEN Yangle:=Yangle-360;
  IF Zangle>359 THEN Zangle:=Zangle-360;

  graphwait;
  Draw3Dobject;
 UNTIL keypressed;

 InitGraph ($3);
END.